#include <memory.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include "../gdbm-local.h"

#include "../curses.h"
#include "../struktury.h"
#include "../struktury_dbm.h"

void zaznamenej(struct zaznam pomocny, DBM * dbm_ptr)
{
    datum klic;
    datum data;
    struct zaznam nacteno;
    int navrat;
    wint_t klavesa;


    clear();
    printw("Ukládám záznam ...\n");
    refresh();

    klic.dptr = (void *) pomocny.kod;
    klic.dsize = wcslen(pomocny.kod) * sizeof(pomocny.kod[0]);

    data.dptr = (void *) &pomocny;
    data.dsize = sizeof(struct zaznam);

    navrat = dbm_store(dbm_ptr, klic, data, DBM_INSERT);

    if (navrat) {
	if (navrat == 1) {
	    data = dbm_fetch(dbm_ptr, klic);
	    memcpy(&nacteno, data.dptr, data.dsize);

	    attron(COLOR_PAIR(CERVENA));
	    printw("ZÁZNAM JIŽ EXISTUJE\nCHCETE PŘEPSAT ZÁZNAM\n");
	    attroff(COLOR_PAIR(CERVENA));
	    printw8(L"[%4ls %-40ls %5i %5i %6i %6i]\n", nacteno.kod,
		    nacteno.nazev, nacteno.semestr, nacteno.vsemestru,
		    nacteno.kreditu, nacteno.znamka);
	    attron(COLOR_PAIR(CERVENA));
	    printw("ZÁZNAMEM\n");
	    attroff(COLOR_PAIR(CERVENA));
	    printw8(L"[%4ls %-40ls %5i %5i %6i %6i]\n", pomocny.kod,
		    pomocny.nazev, pomocny.semestr, pomocny.vsemestru,
		    pomocny.kreditu, pomocny.znamka);
	    attron(COLOR_PAIR(CERVENA));
	    printw("\n[A/N]? ");
	    attroff(COLOR_PAIR(CERVENA));

	    do {
		(void) get_wch(&klavesa);
		switch (klavesa) {
		case L'n':
		case L'N':
		    return;
		    break;
		case L'a':
		case L'A':
		    data.dptr = (void *) &pomocny;
		    data.dsize = sizeof(struct zaznam);

		    if (dbm_store(dbm_ptr, klic, data, DBM_REPLACE)) {
			printw("\nZáznam nelze uložit!\n");
		    } else
			printw("\nZáznam byl úspěšně přepsán.\n");
		    break;
		}
	    }
	    while (klavesa != L'a' && klavesa != L'A');

	} else
	    printw("Záznam nelze uložit.\n");
    } else
	printw("Záznam uložen.\n");

    printw("Pokračujte libovolnou klavesou ...");
    refresh();
    (void) get_wch(&klavesa);
}
